'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _manageDelayTimer = Symbol();

var Loader = function (_Component) {
    _inherits(Loader, _Component);

    function Loader(props) {
        _classCallCheck(this, Loader);

        var _this = _possibleConstructorReturn(this, (Loader.__proto__ || Object.getPrototypeOf(Loader)).call(this, props));

        _this.state = {
            isLoaderActive: false
        };
        return _this;
    }

    _createClass(Loader, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this[_manageDelayTimer]();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this[_manageDelayTimer]();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearInterval(this.delayedTimerId);
        }
    }, {
        key: 'render',
        value: function render() {
            var _classNames;

            var _props = this.props,
                children = _props.children,
                activeClassName = _props.activeClassName,
                disabledClassName = _props.disabledClassName,
                tag = _props.tag;
            var isLoaderActive = this.state.isLoaderActive;

            var className = (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, activeClassName, isLoaderActive), _defineProperty(_classNames, disabledClassName, !isLoaderActive), _classNames));
            var Tag = tag;

            return _react2.default.createElement(
                Tag,
                { className: className },
                children
            );
        }
    }, {
        key: _manageDelayTimer,
        value: function value() {
            var _this2 = this;

            var _props2 = this.props,
                active = _props2.active,
                delay = _props2.delay;
            var isLoaderActive = this.state.isLoaderActive;


            if (!this.delayedTimerId && active && !isLoaderActive && delay > 0) {
                this.delayedTimerId = setTimeout(function () {
                    return _this2.setState(function (prevState, props) {
                        return { isLoaderActive: props.active };
                    });
                }, delay);
            }

            if (this.delayedTimerId && !active) {
                clearTimeout(this.delayedTimerId);
                this.delayedTimerId = null;
            }
        }
    }], [{
        key: 'getDerivedStateFromProps',
        value: function getDerivedStateFromProps(nextProps, prevState) {
            return { isLoaderActive: !prevState.isLoaderActive && nextProps.active && nextProps.delay === 0 };
        }
    }]);

    return Loader;
}(_react.Component);

Loader.defaultProps = {
    activeClassName: '7c-react-loader-active',
    children: null,
    delay: 0,
    disabledClassName: '7c-react-loader-disabled',
    tag: 'div'
};
Loader.propTypes = {
    active: _propTypes2.default.bool.isRequired,
    activeClassName: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array, _propTypes2.default.instanceOf(_classnames2.default)]),
    children: _propTypes2.default.element,
    delay: _propTypes2.default.number,
    disabledClassName: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array, _propTypes2.default.instanceOf(_classnames2.default)]),
    duration: _propTypes2.default.number,
    tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string])
};
exports.default = Loader;
//# sourceMappingURL=index.js.map